using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Data.OracleClient;

public partial class Business_TSearchB24 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            loadEvents();
            loadBankBins();
            pnlControls.Visible = false;
            ExceptionUtility.LogException(0, "", "27", "Page_Load", "");            
        }

        this.lbl_error.Text = "";
    }

    private void loadEvents()
    {
        try
        {
            string DBConnection = Helper.dbConnection();

            OracleConnection oracon = new OracleConnection(DBConnection);
            oracon.Open();

            OracleCommand oracom = new OracleCommand();
            oracom.Connection = oracon;

            oracom.CommandType = CommandType.StoredProcedure;
            oracom.CommandText = "LOOKUP_GETTER.Get_Recon_Events";

            oracom.Parameters.Add("p_recon_events", OracleType.Cursor).Direction = ParameterDirection.Output;

            OracleDataAdapter da = new OracleDataAdapter(oracom);
            DataSet ds = new DataSet();
            da.Fill(ds);

            ddlEvents.DataSource = ds;
            ddlEvents.DataBind();

            ddlEvents.Items.Insert(0, "------ Events ------");
            oracon.Close();
        }
        catch (Exception ex)
        {
            ExceptionUtility.LogException(ex, "LOOKUP_GETTER.Get_Recon_Events","", "loadEvents", "");
            //Response.Redirect("../ErrorPages/ErrorPage.aspx");
        }
    }

    private void loadBankBins()
    {
        try
        {
            string DBConnection = Helper.dbConnection();

            OracleConnection oracon = new OracleConnection(DBConnection);
            oracon.Open();

            OracleCommand oracom = new OracleCommand();
            oracom.Connection = oracon;

            oracom.CommandType = CommandType.StoredProcedure;
            oracom.CommandText = "LOOKUP_GETTER.Get_Bank_Bin";

            oracom.Parameters.Add("p_bank_bin", OracleType.Cursor).Direction = ParameterDirection.Output;

            OracleDataAdapter da = new OracleDataAdapter(oracom);
            DataSet ds = new DataSet();
            da.Fill(ds);

            ddlIssuer.DataSource = ds;
            ddlIssuer.DataBind();

            ddlIssuer.Items.Insert(0, "------ Issuer ------");

            ddlAcquirer.DataSource = ds;
            ddlAcquirer.DataBind();

            ddlAcquirer.Items.Insert(0, "------ Acquirer ------");

            oracon.Close();
        }
        catch (Exception ex)
        {
            ExceptionUtility.LogException(ex, "LOOKUP_GETTER.Get_Bank_Bin","", "loadBankBins", "");
            //Response.Redirect("../ErrorPages/ErrorPage.aspx");
        }
    }

    private void loadResult(string terminalID, string eventID, string Card, string reference, string datefrom, string dateto, int pageSize, int pageNumber)
    {
        string parameters = "";
        try
        {
            
            string DBConnection = Helper.dbConnection();

            OracleConnection oracon = new OracleConnection(DBConnection);
            oracon.Open();

            OracleCommand oracom = new OracleCommand();
            oracom.Connection = oracon;

            oracom.CommandType = CommandType.StoredProcedure;
            oracom.CommandText = "TRANSACTIONS_SEARCHER.Search_Master_Tran";

            oracom.Parameters.Add("p_current_uid", OracleType.Number).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_re_code", OracleType.Number).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_card_no", OracleType.VarChar).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_tran_date_from", OracleType.VarChar).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_tran_date_to", OracleType.VarChar).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_rrn", OracleType.VarChar).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_source", OracleType.Number).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_dest", OracleType.Number).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_atm_num", OracleType.VarChar).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_page_size", OracleType.Number).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_page_num", OracleType.Number).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_lang", OracleType.VarChar).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_res_code", OracleType.Number).Direction = ParameterDirection.Output;
            oracom.Parameters.Add("p_res_type", OracleType.VarChar, 250).Direction = ParameterDirection.Output;
            oracom.Parameters.Add("p_res_msg", OracleType.VarChar, 250).Direction = ParameterDirection.Output;
            oracom.Parameters.Add("p_output", OracleType.Cursor).Direction = ParameterDirection.Output;
            oracom.Parameters.Add("p_total_pages", OracleType.Number).Direction = ParameterDirection.Output;

            if (eventID.Length != 0)
            {
                parameters = "p_re_code-" + eventID;
                oracom.Parameters["p_re_code"].Value = eventID;
            }
            else
                oracom.Parameters["p_re_code"].Value = OracleNumber.Null;
            oracom.Parameters["p_card_no"].Value = Card;
            if (Card.Length > 0)
                parameters = parameters + ":p_card_no-" + Helper.Mask_CardNumber(Card);
            oracom.Parameters["p_tran_date_from"].Value = datefrom;
            if(datefrom .Length >0)
                parameters = parameters + ":p_tran_date_from-" + datefrom;
            oracom.Parameters["p_tran_date_to"].Value = dateto;
            if(dateto .Length >0)
                parameters = parameters + ":p_tran_date_to-" + dateto;
            oracom.Parameters["p_rrn"].Value = reference;
            if (reference.Length > 0)
                parameters = parameters + ":p_rrn-" + reference;
            oracom.Parameters["p_atm_num"].Value = terminalID;
            if(terminalID .Length >0)
                parameters = parameters + ":p_atm_num-" + terminalID;
            if (ddlIssuer.SelectedIndex > 0)
            {
                oracom.Parameters["p_source"].Value = ddlIssuer.SelectedValue;
                parameters = parameters + ":p_source-" + ddlIssuer.SelectedItem.Text;
            }
            else
                oracom.Parameters["p_source"].Value = OracleNumber.Null;
            if (ddlAcquirer.SelectedIndex > 0)
            {
                 oracom.Parameters["p_dest"].Value = ddlIssuer.SelectedItem.Text;
                 parameters = parameters + ":p_dest-" + ddlIssuer.SelectedItem.Text;
         
            }
            else
                oracom.Parameters["p_dest"].Value = OracleNumber.Null;

            oracom.Parameters["p_page_size"].Value = pageSize;
            oracom.Parameters["p_page_num"].Value = pageNumber;
            oracom.Parameters["p_lang"].Value = "EN";
            oracom.Parameters["p_current_uid"].Value = Session["uid"].ToString();

            OracleDataAdapter da = new OracleDataAdapter(oracom);
            DataSet ds = new DataSet();
            da.Fill(ds);

            int nop = int.Parse(oracom.Parameters["p_total_pages"].Value.ToString());
            oracon.Close();

            GridView1.DataSource = ds;
            GridView1.DataBind();
            if (pageNumber == 1)
            {
                ddlPages.Items.Clear();
                for (int i = 1; i <= nop; i++)
                {
                    ddlPages.Items.Add(i.ToString());
                }
            }
            ExceptionUtility.LogException(0, "TRANSACTIONS_SEARCHER.Search_Master_Tran", "173.1", "loadResult", parameters);
        }
        catch (Exception ex)
        {
            ExceptionUtility.LogException(ex, "TRANSACTIONS_SEARCHER.Search_Master_Tran","173.1", "loadResult",parameters );
            GridView1.DataSource = null;
            GridView1.DataBind();
            //Response.Redirect("../ErrorPages/ErrorPage.aspx");
        }
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        string selectedCardNumber = this.lov_cardNumbers.getSelectedCardNumber();
        double cardNumber;

        if (selectedCardNumber.Length != 0 && double.TryParse(selectedCardNumber, out cardNumber))
        {
            string EventID = "";
            if (ddlEvents.SelectedIndex > 0)
                EventID = ddlEvents.SelectedValue;
            pnlResult.Visible = true;
            ExceptionUtility.LogException(0, "", "27.173", "Button1_Click", "");
            loadResult(this.txtTerminal.Text, EventID, this.lov_cardNumbers.getSelectedCardNumber(), txtReferenceNumber.Text, DatePicker1.date, DatePicker2.date, Helper.gridSize(), 1);
            pnlControls.Visible = false;
        }
        else if (selectedCardNumber.Length == 0)
        {
            ExceptionUtility.LogException(9, "", "27.173", "Button1_Click", "");
            this.lbl_error.Text = "Please enter Card Number";
        }
        else
        {
            ExceptionUtility.LogException(9, "", "27.173", "Button1_Click", "");
            this.lbl_error.Text = "Please enter a valid Card Number";
        }
    }

    protected void ddlPages_SelectedIndexChanged(object sender, EventArgs e)
    {
        string EventID = "";
        if (ddlEvents.SelectedIndex > 0)
            EventID = ddlEvents.SelectedValue;
        ExceptionUtility.LogException(0, "", "", "ddlPages_SelectedIndexChanged", ddlPages .SelectedItem .Text );
        loadResult(this.txtTerminal.Text, EventID, this.lov_cardNumbers.getSelectedCardNumber(), txtReferenceNumber.Text, DatePicker1.date, DatePicker2.date, Helper.gridSize(), int.Parse(ddlPages.SelectedValue));
        pnlControls.Visible = false;
    }

    protected void GridView1_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName.Equals("v"))
        {
            ExceptionUtility.LogException(0, "", "27.174", "GridView1_RowCommand.ViewTransactionDetails", "");
            int index = int.Parse(e.CommandArgument.ToString());
            string tID = GridView1.DataKeys[index].Value.ToString();
            loadTranDetails(tID);
            pnlDataCode.Visible = false;
            pnlDatacodeError.Visible = false;
        }
    }

    private void loadTranDetails(string tID)
    {
        try
        {
            pnlControls.Visible = true;
            string DBConnection = Helper.dbConnection();

            OracleConnection oracon = new OracleConnection(DBConnection);
            oracon.Open();

            OracleCommand oracom = new OracleCommand();
            oracom.Connection = oracon;

            oracom.CommandType = CommandType.StoredProcedure;
            oracom.CommandText = "TRANSACTIONS_SEARCHER.Get_Master_Tran";

            oracom.Parameters.Add("p_mt_code", OracleType.Number).Direction = ParameterDirection.Input;
            oracom.Parameters.Add("p_output", OracleType.Cursor).Direction = ParameterDirection.Output;
            oracom.Parameters.Add("p_match_grid", OracleType.Cursor).Direction = ParameterDirection.Output;

            oracom.Parameters["p_mt_code"].Value = tID;

            OracleDataAdapter da = new OracleDataAdapter(oracom);
            DataSet ds = new DataSet();
            da.Fill(ds);

            oracon.Close();

            //set the data in the controls
            Label1.Text = ds.Tables[0].Rows[0]["RECORD_DATE"].ToString();
            Label2.Text = ds.Tables[0].Rows[0]["SETTL_DATE"].ToString();

            Label3.Text = ds.Tables[0].Rows[0]["TRAN_DATE"].ToString();
            Label4.Text = ds.Tables[0].Rows[0]["TRAN_TIME"].ToString();
            Label5.Text = ds.Tables[0].Rows[0]["CARD_NUMBER"].ToString();
            Label6.Text = ds.Tables[0].Rows[0]["PCODE"].ToString();
            Label7.Text = ds.Tables[0].Rows[0]["FINANCIAL_FLAG"].ToString();
            Label8.Text = ds.Tables[0].Rows[0]["B24_RSP"].ToString();
            Label9.Text = ds.Tables[0].Rows[0]["ISO_RSP"].ToString();
            Label10.Text = ds.Tables[0].Rows[0]["TERM_ID"].ToString();
            Label11.Text = ds.Tables[0].Rows[0]["TRAN_AMOUNT"].ToString();
            Label12.Text = ds.Tables[0].Rows[0]["TRAN_SOURCE"].ToString();
            Label13.Text = ds.Tables[0].Rows[0]["TRAN_DEST"].ToString();
            Label14.Text = ds.Tables[0].Rows[0]["MSG_TYPE"].ToString();
            Label15.Text = ds.Tables[0].Rows[0]["TRACE_ID"].ToString();
            Label16.Text = ds.Tables[0].Rows[0]["FILE_NUMBER"].ToString();
            Label17.Text = ds.Tables[0].Rows[0]["CARD_BRAND"].ToString();
            Label18.Text = ds.Tables[0].Rows[0]["RRN"].ToString();
            Label19.Text = ds.Tables[0].Rows[0]["CARD_EXP_DATE"].ToString();
            Label20.Text = ds.Tables[0].Rows[0]["ACCT_NUMBER"].ToString();
            Label21.Text = ds.Tables[0].Rows[0]["AUTH_CODE"].ToString();
            Label22.Text = ds.Tables[0].Rows[0]["BUSS_CLASS"].ToString();
            Label23.Text = ds.Tables[0].Rows[0]["TRAN_STATUS"].ToString();
            Label24.Text = ds.Tables[0].Rows[0]["TRAN_CURR"].ToString();
            Label25.Text = ds.Tables[0].Rows[0]["SETTL_CURR"].ToString();
            Label26.Text = ds.Tables[0].Rows[0]["SETTL_AMOUNT"].ToString();
            Label27.Text = ds.Tables[0].Rows[0]["TRAN_CHG"].ToString();
            Label28.Text = ds.Tables[0].Rows[0]["RECON_REQ_FLAG"].ToString();
            Label29.Text = ds.Tables[0].Rows[0]["RECON_PERFORMED_FLAG"].ToString();
            Label30.Text = ds.Tables[0].Rows[0]["MATCH_CRIERIA"].ToString();
            Label31.Text = ds.Tables[0].Rows[0]["MATCH_REF1"].ToString();
            Label32.Text = ds.Tables[0].Rows[0]["MATCH_REF2"].ToString();
            Label33.Text = ds.Tables[0].Rows[0]["MATCH_REF3"].ToString();
            Label34.Text = ds.Tables[0].Rows[0]["MATCH_REF4"].ToString();
            Label35.Text = ds.Tables[0].Rows[0]["MATCH_DATE1"].ToString();
            Label36.Text = ds.Tables[0].Rows[0]["MATCH_DATE2"].ToString();
            Label37.Text = ds.Tables[0].Rows[0]["MATCH_DATE3"].ToString();
            Label38.Text = ds.Tables[0].Rows[0]["MATCH_DATE4"].ToString();
            Label39.Text = ds.Tables[0].Rows[0]["CHIP_DATA"].ToString();
            Label40.Text = ds.Tables[0].Rows[0]["NEXT_MATCH"].ToString();
            Label41.Text = ds.Tables[0].Rows[0]["re_code"].ToString();
            Label42.Text = ds.Tables[0].Rows[0]["PRODUCT"].ToString();
            Label43.Text = ds.Tables[0].Rows[0]["ORIG_OSEQ_NUM"].ToString();
            Label44.Text = ds.Tables[0].Rows[0]["ORIG_DATE"].ToString();
            Label45.Text = ds.Tables[0].Rows[0]["ORIG_TIME"].ToString();
            Label46.Text = ds.Tables[0].Rows[0]["AMT_2"].ToString();
            Label47.Text = ds.Tables[0].Rows[0]["AMT_3"].ToString();
            Label48.Text = ds.Tables[0].Rows[0]["AUTH_AMT"].ToString();
            Label49.Text = ds.Tables[0].Rows[0]["merch_settle_desc"].ToString();
            btnDatacode.Text = ds.Tables[0].Rows[0]["pos_datacode"].ToString() + " : Click to see details.";
            ViewState["pos_datacode"] = ds.Tables[0].Rows[0]["pos_datacode"].ToString();

            GridView2.DataSource = ds.Tables[1];
            GridView2.DataBind();
        }
        catch (Exception ex)
        {
            ExceptionUtility.LogException(ex, "TRANSACTIONS_SEARCHER.Get_Master_Tran","174.1", "loadTranDetails", "tID: " + tID );
            GridView2.DataSource = null;
            GridView2.DataBind();
            //Response.Redirect("../ErrorPages/ErrorPage.aspx");
        }
    }

    protected void btnCancel_Click(object sender, EventArgs e)
    {
        pnlControls.Visible = false;
        ExceptionUtility.LogException(0, "", "", "btnCancel_Click", "");
    }
    
    protected void ddlEvents_SelectedIndexChanged(object sender, EventArgs e)
    {
        pnlControls.Visible = false;
        pnlResult.Visible = false;
        ExceptionUtility.LogException(0, "", "", "ddlEvents_SelectedIndexChanged", ddlEvents .SelectedItem .Text );
        if (ddlEvents.SelectedIndex != 0)
        {
            int selectedEventId = int.Parse(this.ddlEvents.SelectedValue.ToString());

            string eventType = Helper.getEventType(selectedEventId);

            if (eventType.Equals("OUS"))
            {
                this.ddlAcquirer.SelectedValue = Constants.BANK_ID;
                this.ddlIssuer.SelectedValue = Constants.BANK_ID;

                this.ddlIssuer.Enabled = false;
                this.ddlAcquirer.Enabled = false;
            }
            else if (eventType.Equals("ACQ"))
            {
                this.ddlAcquirer.SelectedValue = Constants.BANK_ID;
                this.ddlAcquirer.Enabled = false;

                this.ddlIssuer.SelectedIndex = 0;
                this.ddlIssuer.Enabled = true;
            }
            else if (eventType.Equals("ISS"))
            {
                this.ddlIssuer.SelectedValue = Constants.BANK_ID;
                this.ddlIssuer.Enabled = false;

                this.ddlAcquirer.SelectedIndex = 0;
                this.ddlAcquirer.Enabled = true;
            }
            else
            {
                this.ddlAcquirer.SelectedIndex = 0;
                this.ddlAcquirer.Enabled = true;

                this.ddlIssuer.SelectedIndex = 0;
                this.ddlIssuer.Enabled = true;
            }
        }
    }
    protected void btnDatacode_Click(object sender, EventArgs e)
    {
        string code = ViewState["pos_datacode"].ToString();
        int resCode;
        string dataCode;



        string DBConnection = Helper.dbConnection();
        OracleConnection oracon = new OracleConnection(DBConnection);
        oracon.Open();

        OracleCommand oracom = new OracleCommand();
        oracom.Connection = oracon;

        oracom.CommandType = CommandType.StoredProcedure;
        oracom.CommandText = "Poslookup_getter.get_POSServData_Desc";

        oracom.Parameters.Add("p_PosCode", OracleType.VarChar).Direction = ParameterDirection.Input;
        oracom.Parameters.Add("p_Mode", OracleType.VarChar).Direction = ParameterDirection.Input;
        oracom.Parameters.Add("p_lang", OracleType.VarChar).Direction = ParameterDirection.Input;

        oracom.Parameters.Add("p_POSDesc", OracleType.VarChar, 1000).Direction = ParameterDirection.Output;
        oracom.Parameters.Add("p_res_code", OracleType.Number).Direction = ParameterDirection.Output;
        oracom.Parameters.Add("p_res_type", OracleType.VarChar, 250).Direction = ParameterDirection.Output;
        oracom.Parameters.Add("p_res_msg", OracleType.VarChar, 250).Direction = ParameterDirection.Output;


        oracom.Parameters["p_PosCode"].Value = code;
        oracom.Parameters["p_Mode"].Value = "M";
        oracom.Parameters["p_lang"].Value = "en";

        oracom.ExecuteNonQuery();
        oracon.Close();

        resCode = int.Parse(oracom.Parameters["p_res_code"].Value.ToString());
        dataCode = oracom.Parameters["p_POSDesc"].Value.ToString();

        if (resCode == 0)
        {
            pnlDataCode.Visible = true;
            string[] dataCodes = dataCode.Split(';');

            lblDataCode1.Text = dataCodes[0];
            lblDataCode2.Text = dataCodes[1];
            lblDataCode3.Text = dataCodes[2];
            lblDataCode4.Text = dataCodes[3];
            lblDataCode5.Text = dataCodes[4];
            lblDataCode6.Text = dataCodes[5];
            lblDataCode7.Text = dataCodes[6];
            lblDataCode8.Text = dataCodes[7];
            lblDataCode9.Text = dataCodes[8];
            lblDataCode10.Text = dataCodes[9];
            lblDataCode11.Text = dataCodes[10];
            lblDataCode12.Text = dataCodes[11];
        }
        else
        {
            lblDataCodeError.Text = dataCode;
            pnlDatacodeError.Visible = true;
        }
    }
}
